<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/management_bar_button/init.jsp" %>

<aui:a cssClass="<%= cssClass %>" data="<%= data %>" href="<%= href %>" iconCssClass="<%= iconCssClass %>" id="<%= id %>">
	<c:if test="<%= Validator.isNotNull(icon) %>">
		<aui:icon cssClass="icon-monospaced" image="<%= icon %>" markupView="lexicon" />
	</c:if>

	<span class="<%= labelCssClass %>"><liferay-ui:message key="<%= label %>" /></span>
</aui:a>