Liferay.Loader.define("frontend-taglib@5.6.15/translation_manager/components/DeleteLocaleModal", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', '@frontend-taglib-clay$clayui/modal', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = DeleteLocaleModal;

    var _button = _interopRequireDefault(require("@frontend-taglib-clay$clayui/button"));

    var _modal = _interopRequireDefault(require("@frontend-taglib-clay$clayui/modal"));

    var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function DeleteLocaleModal(_ref) {
      var observer = _ref.observer,
          onCancel = _ref.onCancel,
          onConfirm = _ref.onConfirm;
      return (/*#__PURE__*/_react.default.createElement(_modal.default, {
          observer: observer,
          size: "sm"
        }, /*#__PURE__*/_react.default.createElement(_modal.default.Body, null, /*#__PURE__*/_react.default.createElement("h4", null, Liferay.Language.get('are-you-sure-you-want-to-deactivate-this-language'))), /*#__PURE__*/_react.default.createElement(_modal.default.Footer, {
          last: /*#__PURE__*/_react.default.createElement(_button.default.Group, {
            spaced: true
          }, /*#__PURE__*/_react.default.createElement(_button.default, {
            displayType: "secondary",
            onClick: onCancel
          }, Liferay.Language.get('dismiss')), /*#__PURE__*/_react.default.createElement(_button.default, {
            onClick: onConfirm
          }, Liferay.Language.get('delete')))
        }))
      );
    }
    //# sourceMappingURL=DeleteLocaleModal.js.map
  }
});
//# sourceMappingURL=DeleteLocaleModal.js.map