Liferay.Loader.define("layout-content-page-editor-web@2.0.157/page_editor/app/components/AllowedFragmentTreeNode", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/form', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = AllowedFragmentTreeNode;

    var _form = require("@frontend-taglib-clay$clayui/form");

    var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    function hasSomeChildrenSelected(node) {
      return node.children.some(function (children) {
        return children.selected || hasSomeChildrenSelected(children);
      });
    }

    function AllowedFragmentTreeNode(_ref) {
      var node = _ref.node;
      return (/*#__PURE__*/_react.default.createElement("div", {
          className: "lfr-treeview-label mt-2"
        }, /*#__PURE__*/_react.default.createElement(_form.ClayCheckbox, {
          "aria-label": node.name,
          checked: node.selected,
          indeterminate: !node.selected && hasSomeChildrenSelected(node),
          label: node.name,
          onChange: function onChange() {},
          onDoubleClick: function onDoubleClick(event) {
            event.stopPropagation();
          }
        }))
      );
    }
    //# sourceMappingURL=AllowedFragmentTreeNode.js.map
  }
});
//# sourceMappingURL=AllowedFragmentTreeNode.js.map