Liferay.Loader.define("product-navigation-control-menu@5.0.48/js/Collection", ['module', 'exports', 'require', 'frontend-js-react-web$classnames', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', './AddPanel', './Collapse', './TabItem'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _classnames = _interopRequireDefault(require("frontend-js-react-web$classnames"));

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _AddPanel = require("./AddPanel");

    var _Collapse = _interopRequireDefault(require("./Collapse"));

    var _TabItem = _interopRequireDefault(require("./TabItem"));

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var Collection = function Collection(_ref) {
      var collection = _ref.collection,
          isContentTab = _ref.isContentTab,
          isSearchResult = _ref.isSearchResult,
          open = _ref.open;

      var _useContext = (0, _react.useContext)(_AddPanel.AddPanelContext),
          displayGrid = _useContext.displayGrid;

      return (/*#__PURE__*/_react.default.createElement(_Collapse.default, {
          key: collection.collectionId,
          label: collection.label,
          open: isSearchResult || open
        }, collection.collections && collection.collections.map(function (collection, index) {
          return (/*#__PURE__*/_react.default.createElement(Collection, {
              collection: collection,
              isSearchResult: isSearchResult,
              key: index
            })
          );
        }), /*#__PURE__*/_react.default.createElement("ul", {
          className: (0, _classnames.default)('list-unstyled', {
            grid: isContentTab && displayGrid
          })
        }, collection.children.map(function (item) {
          var _item$portletItems;

          return (/*#__PURE__*/_react.default.createElement(_react.default.Fragment, {
              key: item.itemId
            }, /*#__PURE__*/_react.default.createElement(_TabItem.default, {
              item: item
            }), ((_item$portletItems = item.portletItems) === null || _item$portletItems === void 0 ? void 0 : _item$portletItems.length) && /*#__PURE__*/_react.default.createElement(TabPortletItem, {
              items: item.portletItems
            }))
          );
        })))
      ); // ));
    };

    var TabPortletItem = function TabPortletItem(_ref2) {
      var items = _ref2.items;
      return (/*#__PURE__*/_react.default.createElement("ul", {
          className: "list-unstyled"
        }, items.map(function (item) {
          return (/*#__PURE__*/_react.default.createElement(_TabItem.default, {
              item: item,
              key: item.data.portletItemId
            })
          );
        }))
      );
    };

    var _default = Collection;
    exports.default = _default;
    //# sourceMappingURL=Collection.js.map
  }
});
//# sourceMappingURL=Collection.js.map