Liferay.Loader.define("product-navigation-control-menu@5.0.48/js/ContentOptions", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/button', '@frontend-taglib-clay$clayui/drop-down', '@frontend-taglib-clay$clayui/form', '@frontend-taglib-clay$clayui/icon', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', './AddPanel'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _button = _interopRequireDefault(require("@frontend-taglib-clay$clayui/button"));

    var _dropDown = _interopRequireDefault(require("@frontend-taglib-clay$clayui/drop-down"));

    var _form = _interopRequireWildcard(require("@frontend-taglib-clay$clayui/form"));

    var _icon = _interopRequireDefault(require("@frontend-taglib-clay$clayui/icon"));

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _AddPanel = require("./AddPanel");

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    var OPTIONS = [{
      label: Liferay.Util.sub(Liferay.Language.get('x-items'), 4),
      value: 4
    }, {
      label: Liferay.Util.sub(Liferay.Language.get('x-items'), 8),
      value: 8
    }, {
      label: Liferay.Util.sub(Liferay.Language.get('x-items'), 10),
      value: 10
    }];

    var ContentOptions = function ContentOptions(_ref) {
      var onChangeSelect = _ref.onChangeSelect;

      var _useContext = (0, _react.useContext)(_AddPanel.AddPanelContext),
          addContentsURLs = _useContext.addContentsURLs,
          displayGrid = _useContext.displayGrid,
          portletNamespace = _useContext.portletNamespace,
          setDisplayGrid = _useContext.setDisplayGrid;

      var _useState = (0, _react.useState)(false),
          _useState2 = _slicedToArray(_useState, 2),
          active = _useState2[0],
          setActive = _useState2[1];

      return (/*#__PURE__*/_react.default.createElement("div", {
          className: "sidebar-body__add-panel__content-options"
        }, /*#__PURE__*/_react.default.createElement(_form.default.Group, {
          small: true
        }, /*#__PURE__*/_react.default.createElement(_form.ClaySelectWithOption, {
          "aria-label": "Select Label",
          className: "btn-monospaced sidebar-body__add-panel__content-options-select",
          defaultValue: 10,
          id: "".concat(portletNamespace, "_contentDropdown"),
          onChange: function onChange(event) {
            return onChangeSelect(event.target.value);
          },
          options: OPTIONS,
          sizing: "sm"
        })), /*#__PURE__*/_react.default.createElement(_button.default, {
          className: "btn-monospaced sidebar-body__add-panel__content-options-list",
          displayType: "unstyled",
          onClick: function onClick() {
            return setDisplayGrid(!displayGrid);
          },
          small: true,
          title: Liferay.Language.get('display-style')
        }, /*#__PURE__*/_react.default.createElement(_icon.default, {
          symbol: displayGrid ? 'cards2' : 'list'
        }), /*#__PURE__*/_react.default.createElement("span", {
          className: "sr-only"
        }, Liferay.Language.get('display-style'))), !!addContentsURLs.length && /*#__PURE__*/_react.default.createElement(_dropDown.default, {
          active: active,
          menuElementAttrs: {
            containerProps: {
              className: 'cadmin'
            }
          },
          onActiveChange: setActive,
          trigger: /*#__PURE__*/_react.default.createElement(_button.default, {
            className: "btn-monospaced sidebar-body__add-panel__content-options-add",
            displayType: "unstyled",
            small: true,
            title: Liferay.Language.get('add-new')
          }, /*#__PURE__*/_react.default.createElement(_icon.default, {
            symbol: "plus"
          }), /*#__PURE__*/_react.default.createElement("span", {
            className: "sr-only"
          }, Liferay.Language.get('add-new')))
        }, /*#__PURE__*/_react.default.createElement(_dropDown.default.ItemList, null, addContentsURLs.map(function (content, index) {
          return (/*#__PURE__*/_react.default.createElement(_dropDown.default.Item, {
              key: index,
              onClick: function onClick() {
                setActive(false);
                Liferay.Util.navigate(content.url);
              }
            }, content.label)
          );
        }))))
      );
    };

    var _default = ContentOptions;
    exports.default = _default;
    //# sourceMappingURL=ContentOptions.js.map
  }
});
//# sourceMappingURL=ContentOptions.js.map