Liferay.Loader.define("product-navigation-control-menu@5.0.48/js/DragAndDrop", ['module', 'exports', 'require', 'frontend-js-react-web$react', 'frontend-js-react-web$react-dom', './useDragAndDrop'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _reactDom = require("frontend-js-react-web$react-dom");

    var _useDragAndDrop = require("./useDragAndDrop");

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    var DragAndDropElements = function DragAndDropElements() {
      var _useState = (0, _react.useState)({}),
          _useState2 = _slicedToArray(_useState, 2),
          dragIndicatorPosition = _useState2[0],
          setDragIndicatorPosition = _useState2[1];

      var _useState3 = (0, _react.useState)(null),
          _useState4 = _slicedToArray(_useState3, 2),
          dropTargetColumn = _useState4[0],
          setDropTargetColumn = _useState4[1];

      var _useState5 = (0, _react.useState)(null),
          _useState6 = _slicedToArray(_useState5, 2),
          dropTargetItem = _useState6[0],
          setDropTargetItem = _useState6[1];

      var columnHasChildren = dropTargetColumn && !dropTargetColumn.firstElementChild.classList.contains('empty');
      var dropItems = Array.from(document.querySelectorAll('.portlet-dropzone, .portlet-dropzone .portlet-boundary'));
      var body = document.body;
      return (/*#__PURE__*/_react.default.createElement(_useDragAndDrop.DragAndDropProvider, {
          value: {
            dragIndicatorPosition: dragIndicatorPosition,
            dropTargetColumn: dropTargetColumn,
            dropTargetItem: dropTargetItem,
            setDragIndicatorPosition: setDragIndicatorPosition,
            setDropTargetColumn: setDropTargetColumn,
            setDropTargetItem: setDropTargetItem
          }
        }, columnHasChildren && /*#__PURE__*/(0, _reactDom.createPortal)( /*#__PURE__*/_react.default.createElement(DragIndicator, {
          position: dragIndicatorPosition
        }), document.body), dropItems.map(function (dropItem, index) {
          return (/*#__PURE__*/_react.default.createElement(DropTarget, {
              dropItem: dropItem,
              key: index
            })
          );
        }), /*#__PURE__*/_react.default.createElement(Wrapper, {
          item: body
        }))
      );
    };

    var DragIndicator = function DragIndicator(_ref) {
      var position = _ref.position;
      return (/*#__PURE__*/_react.default.createElement("div", {
          className: "sortable-layout-drag-indicator sortable-layout-drag-target-indicator",
          style: {
            left: position.clientX,
            top: position.clientY,
            width: position.width
          }
        })
      );
    };

    var DropTarget = function DropTarget(_ref2) {
      var dropItem = _ref2.dropItem;
      (0, _useDragAndDrop.useDropTarget)(dropItem);
      return null;
    };

    var Wrapper = function Wrapper(_ref3) {
      var item = _ref3.item;
      (0, _useDragAndDrop.useDropClear)(item);
      return null;
    };

    var _default = DragAndDropElements;
    exports.default = _default;
    //# sourceMappingURL=DragAndDrop.js.map
  }
});
//# sourceMappingURL=DragAndDrop.js.map