<%--
/**
 * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
 *
 * The contents of this file are subject to the terms of the Liferay Enterprise
 * Subscription License ("License"). You may not use this file except in
 * compliance with the License. You can obtain a copy of the License by
 * contacting Liferay, Inc. See the License for the specific language governing
 * permissions and limitations under the License, including but not limited to
 * distribution rights of the Software.
 *
 *
 *
 */
--%>

<%@ include file="/sidebar_panel/init.jsp" %>

<div aria-label="<%= Validator.isNotNull(title) ? title : StringPool.BLANK %>" class="info-panel sidenav-menu-slider" role="tabpanel" tabindex="-1">
	<div class="sidebar sidebar-default sidenav-menu">
		<c:if test="<%= closeButton %>">
			<clay:button
				aria-label='<%= Validator.isNotNull(title) ? LanguageUtil.format(request, "close-x", title, false) : StringPool.BLANK %>'
				borderless="<%= true %>"
				cssClass="d-flex sidenav-close"
				displayType="secondary"
				monospaced="<%= true %>"
				outline="<%= true %>"
				small="<%= true %>"
				title='<%= LanguageUtil.get(request, "close") %>'
			>
				<span class="c-inner" tabindex="-1">
					<span class="inline-item">
						<clay:icon
							symbol="times"
						/>
					</span>
				</span>
			</clay:button>
		</c:if>

		<div class="info-panel-content" id="<%= namespace %>sidebarPanel">
