Liferay.Loader.define("layout-content-page-editor-web@2.0.157/page_editor/app/actions/addMappedInfoItems", ['module', 'exports', 'require', './types'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = addMappedInfoItems;

    var _types = require("./types");

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */

    /**
     * @param {object} options
     * @param {string} options.className
     * @param {string} options.classNameId
     * @param {string} options.classPK
     * @param {string} options.title
     * @return {object}
     */
    function addMappedInfoItems(infoItems) {
      return {
        infoItems: infoItems,
        type: _types.ADD_MAPPED_INFO_ITEM
      };
    }
    //# sourceMappingURL=addMappedInfoItems.js.map
  }
});
//# sourceMappingURL=addMappedInfoItems.js.map