Liferay.Loader.define("layout-content-page-editor-web@2.0.157/page_editor/app/components/ExperimentsLabel", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/label', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = ExperimentsLabel;

    var _label = _interopRequireDefault(require("@frontend-taglib-clay$clayui/label"));

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

    var _STATUS_TO_TYPE;

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    var STATUS_COMPLETED = 2;
    var STATUS_DRAFT = 0;
    var STATUS_FINISHED_NO_WINNER = 4;
    var STATUS_FINISHED_WINNER = 3;
    var STATUS_PAUSED = 5;
    var STATUS_RUNNING = 1;
    var STATUS_SCHEDULED = 7;
    var STATUS_TERMINATED = 6;
    var STATUS_TO_TYPE = (_STATUS_TO_TYPE = {}, _defineProperty(_STATUS_TO_TYPE, STATUS_COMPLETED, 'success'), _defineProperty(_STATUS_TO_TYPE, STATUS_DRAFT, 'secondary'), _defineProperty(_STATUS_TO_TYPE, STATUS_FINISHED_NO_WINNER, 'secondary'), _defineProperty(_STATUS_TO_TYPE, STATUS_FINISHED_WINNER, 'success'), _defineProperty(_STATUS_TO_TYPE, STATUS_PAUSED, 'warning'), _defineProperty(_STATUS_TO_TYPE, STATUS_RUNNING, 'primary'), _defineProperty(_STATUS_TO_TYPE, STATUS_SCHEDULED, 'warning'), _defineProperty(_STATUS_TO_TYPE, STATUS_TERMINATED, 'danger'), _STATUS_TO_TYPE);

    function ExperimentsLabel(_ref) {
      var label = _ref.label,
          value = _ref.value;
      var displayType = STATUS_TO_TYPE[value];
      return (/*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement("span", {
          className: "mr-1 text-secondary"
        }, Liferay.Language.get('ab-test')), /*#__PURE__*/_react.default.createElement(_label.default, {
          displayType: displayType
        }, label))
      );
    }
    //# sourceMappingURL=ExperimentsLabel.js.map
  }
});
//# sourceMappingURL=ExperimentsLabel.js.map