Liferay.Loader.define("layout-content-page-editor-web@2.0.157/page_editor/app/components/TopperEmpty", ['module', 'exports', 'require', 'frontend-js-react-web$classnames', 'frontend-js-react-web$react', '../../prop-types/index', '../selectors/selectCanUpdatePageStructure', '../store/index', '../utils/dragAndDrop/constants/targetPosition', '../utils/dragAndDrop/useDragAndDrop', '../utils/getLayoutDataItemLabel'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = _default;

    var _classnames = _interopRequireDefault(require("frontend-js-react-web$classnames"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _index = require("../../prop-types/index");

    var _selectCanUpdatePageStructure = _interopRequireDefault(require("../selectors/selectCanUpdatePageStructure"));

    var _index2 = require("../store/index");

    var _targetPosition = require("../utils/dragAndDrop/constants/targetPosition");

    var _useDragAndDrop = require("../utils/dragAndDrop/useDragAndDrop");

    var _getLayoutDataItemLabel = _interopRequireDefault(require("../utils/getLayoutDataItemLabel"));

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    function _objectWithoutProperties(source, excluded) {
      if (source == null) return {};var target = _objectWithoutPropertiesLoose(source, excluded);var key, i;if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);for (i = 0; i < sourceSymbolKeys.length; i++) {
          key = sourceSymbolKeys[i];if (excluded.indexOf(key) >= 0) continue;if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;target[key] = source[key];
        }
      }return target;
    }

    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null) return {};var target = {};var sourceKeys = Object.keys(source);var key, i;for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];if (excluded.indexOf(key) >= 0) continue;target[key] = source[key];
      }return target;
    }

    function _default(_ref) {
      var children = _ref.children,
          props = _objectWithoutProperties(_ref, ["children"]);

      var canUpdatePageStructure = (0, _index2.useSelector)(_selectCanUpdatePageStructure.default);
      return canUpdatePageStructure ? /*#__PURE__*/_react.default.createElement(TopperEmpty, props, children) : children;
    }

    function TopperEmpty(_ref2) {
      var children = _ref2.children,
          item = _ref2.item;
      var containerRef = (0, _react.useRef)(null);
      var fragmentEntryLinks = (0, _index2.useSelector)(function (state) {
        return state.fragmentEntryLinks;
      });

      var _useDropTarget = (0, _useDragAndDrop.useDropTarget)(item),
          canDropOverTarget = _useDropTarget.canDropOverTarget,
          isOverTarget = _useDropTarget.isOverTarget,
          sourceItem = _useDropTarget.sourceItem,
          targetPosition = _useDropTarget.targetPosition,
          targetRef = _useDropTarget.targetRef;

      var isFragment = children.type === _react.default.Fragment;
      var realChildren = isFragment ? children.props.children : children;
      var notDroppableMessage = isOverTarget && !canDropOverTarget ? Liferay.Util.sub(Liferay.Language.get('a-x-cannot-be-dropped-inside-a-x'), [(0, _getLayoutDataItemLabel.default)(sourceItem, fragmentEntryLinks), (0, _getLayoutDataItemLabel.default)(item, fragmentEntryLinks)]) : null;
      return _react.default.Children.map(realChildren, function (child) {
        if (!child) {
          return child;
        }

        return (/*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.cloneElement(child, _objectSpread(_objectSpread({}, child.props), {}, {
            className: (0, _classnames.default)(child.props.className, {
              'drag-over-bottom': isOverTarget && targetPosition === _targetPosition.TARGET_POSITION.BOTTOM,
              'drag-over-middle': isOverTarget && targetPosition === _targetPosition.TARGET_POSITION.MIDDLE,
              'drag-over-top': isOverTarget && targetPosition === _targetPosition.TARGET_POSITION.TOP,
              'not-droppable': !!notDroppableMessage,
              'page-editor__topper': true
            }),
            'data-not-droppable-message': notDroppableMessage,
            ref: function ref(node) {
              containerRef.current = node;
              targetRef(node); // Call the original ref, if any.

              if (typeof child.ref === 'function') {
                child.ref(node);
              } else if (child.ref && 'current' in child.ref) {
                child.ref.current = node;
              }
            }
          })))
        );
      });
    }
    //# sourceMappingURL=TopperEmpty.js.map
  }
});
//# sourceMappingURL=TopperEmpty.js.map