Liferay.Loader.define("layout-content-page-editor-web@2.0.157/page_editor/app/components/WidgetsContext", ['module', 'exports', 'require', 'frontend-js-react-web$react', '../selectors/selectSegmentsExperienceId', '../services/WidgetService', '../store/index'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.WidgetsContextProvider = WidgetsContextProvider;
    exports.useWidgets = void 0;

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _selectSegmentsExperienceId = _interopRequireDefault(require("../selectors/selectSegmentsExperienceId"));

    var _WidgetService = _interopRequireDefault(require("../services/WidgetService"));

    var _index = require("../store/index");

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _objectWithoutProperties(source, excluded) {
      if (source == null) return {};var target = _objectWithoutPropertiesLoose(source, excluded);var key, i;if (Object.getOwnPropertySymbols) {
        var sourceSymbolKeys = Object.getOwnPropertySymbols(source);for (i = 0; i < sourceSymbolKeys.length; i++) {
          key = sourceSymbolKeys[i];if (excluded.indexOf(key) >= 0) continue;if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue;target[key] = source[key];
        }
      }return target;
    }

    function _objectWithoutPropertiesLoose(source, excluded) {
      if (source == null) return {};var target = {};var sourceKeys = Object.keys(source);var key, i;for (i = 0; i < sourceKeys.length; i++) {
        key = sourceKeys[i];if (excluded.indexOf(key) >= 0) continue;target[key] = source[key];
      }return target;
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    var WidgetsContext = /*#__PURE__*/_react.default.createContext([]);

    var useWidgets = function useWidgets() {
      return (0, _react.useContext)(WidgetsContext);
    };

    exports.useWidgets = useWidgets;

    function normalizePortlets(portlets, fragmentEntryLinks) {
      return portlets.map(function (portlet) {
        var _portlet$portletItems;

        var normalizedPortlet = _objectSpread(_objectSpread({}, portlet), {}, {
          used: Object.values(fragmentEntryLinks).some(function (_ref) {
            var portletId = _ref.portletId;
            return portlet.portletId === portletId;
          })
        });

        if ((_portlet$portletItems = portlet.portletItems) === null || _portlet$portletItems === void 0 ? void 0 : _portlet$portletItems.length) {
          normalizedPortlet.portletItems = normalizePortlets(portlet.portletItems, fragmentEntryLinks);
        }

        return normalizedPortlet;
      });
    }

    function normalizeCategories(categories, fragmentEntryLinks) {
      return categories.map(function (category) {
        var _category$categories;

        var normalizedCategory = _objectSpread(_objectSpread({}, category), {}, {
          portlets: normalizePortlets(category.portlets, fragmentEntryLinks)
        });

        if ((_category$categories = category.categories) === null || _category$categories === void 0 ? void 0 : _category$categories.length) {
          normalizedCategory.categories = normalizeCategories(category.categories, fragmentEntryLinks);
        }

        return normalizedCategory;
      });
    }

    function WidgetsContextProvider(_ref2) {
      var children = _ref2.children;

      var _useState = (0, _react.useState)([]),
          _useState2 = _slicedToArray(_useState, 2),
          widgets = _useState2[0],
          setWidgets = _useState2[1];

      var fragmentEntryLinksRef = (0, _react.useRef)();
      var fragmentEntryLinksIds = (0, _index.useSelector)(function (state) {
        var nextSegmentsExperienceId = (0, _selectSegmentsExperienceId.default)(state);
        return Object.values(state.fragmentEntryLinks).filter(function (_ref3) {
          var portletId = _ref3.portletId,
              removed = _ref3.removed,
              fragmentEntryLink = _objectWithoutProperties(_ref3, ["portletId", "removed"]);

          return portletId && !removed && fragmentEntryLink.segmentsExperienceId === nextSegmentsExperienceId;
        }).map(function (_ref4) {
          var fragmentEntryLinkId = _ref4.fragmentEntryLinkId;
          return fragmentEntryLinkId;
        }).join(',');
      });
      (0, _index.useSelector)(function (state) {
        var nextSegmentsExperienceId = (0, _selectSegmentsExperienceId.default)(state);
        fragmentEntryLinksRef.current = Object.values(state.fragmentEntryLinks).filter(function (_ref5) {
          var portletId = _ref5.portletId,
              removed = _ref5.removed,
              fragmentEntryLink = _objectWithoutProperties(_ref5, ["portletId", "removed"]);

          return portletId && !removed && fragmentEntryLink.segmentsExperienceId === nextSegmentsExperienceId;
        });
        return null;
      });
      (0, _react.useEffect)(function () {
        _WidgetService.default.getWidgets().then(function (categories) {
          return setWidgets(normalizeCategories(categories, fragmentEntryLinksRef.current));
        });
      }, []);
      (0, _react.useEffect)(function () {
        setWidgets(function (currentWidgets) {
          return normalizeCategories(currentWidgets, fragmentEntryLinksRef.current);
        });
      }, [fragmentEntryLinksIds]);
      return (/*#__PURE__*/_react.default.createElement(WidgetsContext.Provider, {
          value: widgets
        }, children)
      );
    }
    //# sourceMappingURL=WidgetsContext.js.map
  }
});
//# sourceMappingURL=WidgetsContext.js.map