Liferay.Loader.define("layout-content-page-editor-web@2.0.157/page_editor/app/components/fragment-configuration-fields/index", ['module', 'exports', 'require', './CheckboxField', './CollectionSelectorField', './ColorPaletteField', './ColorPickerField', './ImageSelectorField', './ItemSelectorField', './SelectField', './TextField'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.FRAGMENT_CONFIGURATION_FIELDS = void 0;

    var _CheckboxField = require("./CheckboxField");

    var _CollectionSelectorField = require("./CollectionSelectorField");

    var _ColorPaletteField = require("./ColorPaletteField");

    var _ColorPickerField = require("./ColorPickerField");

    var _ImageSelectorField = require("./ImageSelectorField");

    var _ItemSelectorField = require("./ItemSelectorField");

    var _SelectField = require("./SelectField");

    var _TextField = require("./TextField");

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var FRAGMENT_CONFIGURATION_FIELDS = {
      checkbox: _CheckboxField.CheckboxField,
      collectionSelector: _CollectionSelectorField.CollectionSelectorField,
      colorPalette: _ColorPaletteField.ColorPaletteField,
      colorPicker: _ColorPickerField.ColorPickerField,
      imageSelector: _ImageSelectorField.ImageSelectorField,
      itemSelector: _ItemSelectorField.ItemSelectorField,
      select: _SelectField.SelectField,
      text: _TextField.TextField
    };
    exports.FRAGMENT_CONFIGURATION_FIELDS = FRAGMENT_CONFIGURATION_FIELDS;
    //# sourceMappingURL=index.js.map
  }
});
//# sourceMappingURL=index.js.map