Liferay.Loader.define("layout-content-page-editor-web@2.0.157/page_editor/app/reducers/baseReducer", ['module', 'exports', 'require', '../actions/types'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = baseReducer;
    exports.INITIAL_STATE = void 0;

    var _types = require("../actions/types");

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    var INITIAL_STATE = {};
    exports.INITIAL_STATE = INITIAL_STATE;

    function baseReducer() {
      var reducers = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : INITIAL_STATE;
      var action = arguments.length > 1 ? arguments[1] : undefined;

      switch (action.type) {
        case _types.LOAD_REDUCER:
          return _objectSpread(_objectSpread({}, reducers), {}, _defineProperty({}, action.key, action.reducer));

        case _types.UNLOAD_REDUCER:
          {
            var nextReducers = _objectSpread({}, reducers);

            delete nextReducers[action.key];
            return nextReducers;
          }

        default:
          return reducers;
      }
    }
    //# sourceMappingURL=baseReducer.js.map
  }
});
//# sourceMappingURL=baseReducer.js.map