Liferay.Loader.define("layout-content-page-editor-web@2.0.157/page_editor/app/reducers/permissionsReducer", ['module', 'exports', 'require', '../actions/types'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = permissionsReducer;
    exports.INITIAL_STATE = void 0;

    var _types = require("../actions/types");

    function ownKeys(object, enumerableOnly) {
      var keys = Object.keys(object);if (Object.getOwnPropertySymbols) {
        var symbols = Object.getOwnPropertySymbols(object);if (enumerableOnly) symbols = symbols.filter(function (sym) {
          return Object.getOwnPropertyDescriptor(object, sym).enumerable;
        });keys.push.apply(keys, symbols);
      }return keys;
    }

    function _objectSpread(target) {
      for (var i = 1; i < arguments.length; i++) {
        var source = arguments[i] != null ? arguments[i] : {};if (i % 2) {
          ownKeys(Object(source), true).forEach(function (key) {
            _defineProperty(target, key, source[key]);
          });
        } else if (Object.getOwnPropertyDescriptors) {
          Object.defineProperties(target, Object.getOwnPropertyDescriptors(source));
        } else {
          ownKeys(Object(source)).forEach(function (key) {
            Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key));
          });
        }
      }return target;
    }

    function _defineProperty(obj, key, value) {
      if (key in obj) {
        Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true });
      } else {
        obj[key] = value;
      }return obj;
    }

    /**
     * @type {import('../../types/ActionKeys').ActionKeysMap}
     */
    var INITIAL_STATE = {
      EDIT_SEGMENTS_ENTRY: false,
      LOCKED_SEGMENTS_EXPERIMENT: false,
      SWITCH_EDIT_MODE: true,
      UPDATE: true,
      UPDATE_LAYOUT_CONTENT: true
    };
    /**
     *
     * @param {import('../../types/ActionKeys').ActionKeysMap} state
     * @param {object} action
     * @param {string} action.type
     * @param {import('../../types/ActionKeys').ACTION_KEYS} action.key
     * @param {boolean} [action.forceNewValue]
     */

    exports.INITIAL_STATE = INITIAL_STATE;

    function permissionsReducer() {
      var state = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : INITIAL_STATE;
      var action = arguments.length > 1 ? arguments[1] : undefined;

      switch (action.type) {
        case _types.TOGGLE_PERMISSION:
          return _objectSpread(_objectSpread({}, state), {}, _defineProperty({}, action.key, typeof action.forceNewValue === 'undefined' ? !state[action.key] : action.forceNewValue));

        case _types.INIT:
          return _objectSpread(_objectSpread({}, state), {}, {
            SWITCH_EDIT_MODE: state.UPDATE
          });

        default:
          return state;
      }
    }
    //# sourceMappingURL=permissionsReducer.js.map
  }
});
//# sourceMappingURL=permissionsReducer.js.map