Liferay.Loader.define("layout-content-page-editor-web@2.0.157/page_editor/app/reducers/selectedViewportSizeReducer", ['module', 'exports', 'require', '../actions/types'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = selectedViewportSizeReducer;
    exports.INITIAL_STATE = void 0;

    var _types = require("../actions/types");

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var INITIAL_STATE = 'desktop';
    exports.INITIAL_STATE = INITIAL_STATE;

    function selectedViewportSizeReducer() {
      var viewportStatus = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : INITIAL_STATE;
      var action = arguments.length > 1 ? arguments[1] : undefined;

      if (action.type === _types.SWITCH_VIEWPORT_SIZE) {
        return action.size;
      }

      return viewportStatus;
    }
    //# sourceMappingURL=selectedViewportSizeReducer.js.map
  }
});
//# sourceMappingURL=selectedViewportSizeReducer.js.map