Liferay.Loader.define("layout-content-page-editor-web@2.0.157/page_editor/app/utils/getFrontendTokenValue", ['module', 'exports', 'require', '../config/index'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.getFrontendTokenValue = getFrontendTokenValue;

    var _index = require("../config/index");

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */

    /**
     * Get widget path from the widgets tree by portletId
     */
    function getFrontendTokenValue(styleValue) {
      var frontendToken = _index.config.frontendTokens[styleValue];

      if (frontendToken) {
        if (Liferay.Browser.isIe()) {
          return frontendToken.value;
        } else {
          return "var(--".concat(frontendToken.cssVariable, ")");
        }
      }

      return styleValue;
    }
    //# sourceMappingURL=getFrontendTokenValue.js.map
  }
});
//# sourceMappingURL=getFrontendTokenValue.js.map