Liferay.Loader.define("product-navigation-control-menu@5.0.48/js/SearchResultPanel", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/alert', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', './Collection'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _alert = _interopRequireDefault(require("@frontend-taglib-clay$clayui/alert"));

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireDefault(require("frontend-js-react-web$react"));

    var _Collection = _interopRequireDefault(require("./Collection"));

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    /**
     * Copyright (c) 2000-present Liferay, Inc. All rights reserved.
     *
     * This library is free software; you can redistribute it and/or modify it under
     * the terms of the GNU Lesser General Public License as published by the Free
     * Software Foundation; either version 2.1 of the License, or (at your option)
     * any later version.
     *
     * This library is distributed in the hope that it will be useful, but WITHOUT
     * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
     * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
     * details.
     */
    var CONTENT_TAB_ID = 'content';

    var SearchResultsPanel = function SearchResultsPanel(_ref) {
      var alertTitle = _ref.alertTitle,
          filteredTabs = _ref.filteredTabs;
      return filteredTabs.map(function (tab, index) {
        return tab.collections.length ? tab.collections.map(function (collection, index) {
          return (/*#__PURE__*/_react.default.createElement(_Collection.default, {
              collection: collection,
              isContentTab: tab.id === CONTENT_TAB_ID,
              isSearchResult: true,
              key: index,
              open: true
            })
          );
        }) : /*#__PURE__*/_react.default.createElement(_alert.default, {
          displayType: "info",
          key: index,
          title: Liferay.Language.get('info')
        }, alertTitle);
      });
    };

    SearchResultsPanel.proptypes = {
      alertTitle: _propTypes.default.string.isRequired,
      filteredTabs: _propTypes.default.object.isRequired
    };
    var _default = SearchResultsPanel;
    exports.default = _default;
    //# sourceMappingURL=SearchResultPanel.js.map
  }
});
//# sourceMappingURL=SearchResultPanel.js.map