Liferay.Loader.define("product-navigation-control-menu@5.0.48/js/TabsPanel", ['module', 'exports', 'require', '@frontend-taglib-clay$clayui/tabs', 'frontend-js-react-web$prop-types', 'frontend-js-react-web$react', './AddPanel', './TabsContent'], function (module, exports, require) {
  var define = undefined;
  var global = window;
  {
    function _typeof(obj) {
      "@babel/helpers - typeof";
      if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") {
        _typeof = function _typeof(obj) {
          return typeof obj;
        };
      } else {
        _typeof = function _typeof(obj) {
          return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj;
        };
      }return _typeof(obj);
    }

    Object.defineProperty(exports, "__esModule", {
      value: true
    });
    exports.default = void 0;

    var _tabs = _interopRequireDefault(require("@frontend-taglib-clay$clayui/tabs"));

    var _propTypes = _interopRequireDefault(require("frontend-js-react-web$prop-types"));

    var _react = _interopRequireWildcard(require("frontend-js-react-web$react"));

    var _AddPanel = require("./AddPanel");

    var _TabsContent = _interopRequireDefault(require("./TabsContent"));

    function _getRequireWildcardCache() {
      if (typeof WeakMap !== "function") return null;var cache = new WeakMap();_getRequireWildcardCache = function _getRequireWildcardCache() {
        return cache;
      };return cache;
    }

    function _interopRequireWildcard(obj) {
      if (obj && obj.__esModule) {
        return obj;
      }if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") {
        return { default: obj };
      }var cache = _getRequireWildcardCache();if (cache && cache.has(obj)) {
        return cache.get(obj);
      }var newObj = {};var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor;for (var key in obj) {
        if (Object.prototype.hasOwnProperty.call(obj, key)) {
          var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null;if (desc && (desc.get || desc.set)) {
            Object.defineProperty(newObj, key, desc);
          } else {
            newObj[key] = obj[key];
          }
        }
      }newObj.default = obj;if (cache) {
        cache.set(obj, newObj);
      }return newObj;
    }

    function _interopRequireDefault(obj) {
      return obj && obj.__esModule ? obj : { default: obj };
    }

    function _slicedToArray(arr, i) {
      return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest();
    }

    function _nonIterableRest() {
      throw new TypeError("Invalid attempt to destructure non-iterable instance");
    }

    function _iterableToArrayLimit(arr, i) {
      if (!(Symbol.iterator in Object(arr) || Object.prototype.toString.call(arr) === "[object Arguments]")) {
        return;
      }var _arr = [];var _n = true;var _d = false;var _e = undefined;try {
        for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) {
          _arr.push(_s.value);if (i && _arr.length === i) break;
        }
      } catch (err) {
        _d = true;_e = err;
      } finally {
        try {
          if (!_n && _i["return"] != null) _i["return"]();
        } finally {
          if (_d) throw _e;
        }
      }return _arr;
    }

    function _arrayWithHoles(arr) {
      if (Array.isArray(arr)) return arr;
    }

    var TabsPanel = function TabsPanel(_ref) {
      var tabs = _ref.tabs;

      var _useContext = (0, _react.useContext)(_AddPanel.AddPanelContext),
          portletNamespace = _useContext.portletNamespace;

      var _useState = (0, _react.useState)(0),
          _useState2 = _slicedToArray(_useState, 2),
          activeTabId = _useState2[0],
          setActiveTabId = _useState2[1];

      var getTabId = function getTabId(tabId) {
        return "".concat(portletNamespace, "_tab_").concat(tabId);
      };

      var getTabPanelId = function getTabPanelId(tabId) {
        return "".concat(portletNamespace, "_tabPanel_").concat(tabId);
      };

      return (/*#__PURE__*/_react.default.createElement(_react.default.Fragment, null, /*#__PURE__*/_react.default.createElement(_tabs.default, {
          className: "sidebar-body__add-panel__tabs",
          modern: true
        }, tabs.map(function (tab, index) {
          return (/*#__PURE__*/_react.default.createElement(_tabs.default.Item, {
              active: activeTabId === index,
              innerProps: {
                'aria-controls': getTabPanelId(index),
                id: getTabId(index)
              },
              key: index,
              onClick: function onClick() {
                return setActiveTabId(index);
              }
            }, tab.label)
          );
        })), /*#__PURE__*/_react.default.createElement(_tabs.default.Content, {
          activeIndex: activeTabId,
          className: "sidebar-body__add-panel__tab-content",
          fade: true
        }, tabs.map(function (tab, index) {
          return (/*#__PURE__*/_react.default.createElement(_tabs.default.TabPane, {
              "aria-labelledby": getTabId(index),
              id: getTabPanelId(index),
              key: index
            }, /*#__PURE__*/_react.default.createElement(_TabsContent.default, {
              tab: tab,
              tabIndex: index
            }))
          );
        })))
      );
    };

    var _default = TabsPanel;
    exports.default = _default;
    //# sourceMappingURL=TabsPanel.js.map
  }
});
//# sourceMappingURL=TabsPanel.js.map